﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System;
using System.Runtime.Serialization;
using HeuristicLab.Common;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;

namespace HeuristicLab.Hive.Contracts.BusinessObjects {
  [StorableClass]
  [Serializable]
  [DataContract]
  public class HivePluginFile : IDeepCloneable {
    [Storable]
    [DataMember]
    public byte[] BinaryFile { get; set; }
    [Storable]
    [DataMember]
    public String Name { get; set; }

    public HivePluginFile() { }
    public HivePluginFile(byte[] binaryFile, String name) {
      BinaryFile = binaryFile;
      Name = name;
    }
    [StorableConstructor]
    protected HivePluginFile(bool deserializing) { }
    protected HivePluginFile(HivePluginFile original, Cloner cloner) {
      cloner.RegisterClonedObject(original, this);
      this.Name = original.Name;
      if (original.BinaryFile != null) {
        this.BinaryFile = new byte[original.BinaryFile.Length];
        Array.Copy(original.BinaryFile, this.BinaryFile, original.BinaryFile.Length);
      }
    }
    public virtual IDeepCloneable Clone(Cloner cloner) {
      return new HivePluginFile(this, cloner);
    }
    public object Clone() {
      return Clone(new Cloner());
    }
  }
}
